<?php

namespace Drupal\murmurations;

use Drupal\Core\Access\AccessResult;
use Drupal\Core\Routing\Access\AccessInterface;

/**
 * Determines access to murmurations profiles.
 */
class ProfileAccess implements AccessInterface  {

  protected $routeMatch;
  protected $murmsPluginManager;

  function __construct(\Drupal\Core\Routing\RouteMatchInterface $route_match, $murmurations_plugin_manager) {
    $this->routeMatch = $route_match;
    $this->murmsPluginManager = $murmurations_plugin_manager;
  }

  /**
   */
   public function access(\Drupal\smallads\Entity\SmalladInterface $smallad) {
    $plugin_id = $this->routeMatch->getRouteObject()->getOption('plugin');
    $plugin = $this->murmsPluginManager->createInstance($plugin_id)->setEntity($smallad);
    return AccessResult::allowedIf($plugin->publishable())->addCacheableDependency($smallad);
  }

}
